// Datei FlorianJut.java
/* ------------------------------------------------------------------------
Diese Klasse dient zum Testen der Klasse Florian.
---------------------------------------------------------------------------
Diese Klasse dient zum Testen der Klasse Florian.
Getestet werden die Methoden blanksRaus und blanksRein.

Diese Klasse kann man auf 2 Arten ausfuehren lassen:

1. Indem man das Programm FlorianJut aufruft (siehe die main-Methode).

2. Indem man in einem bash- oder DOS-Fenster das folgende Kommando eingibt:
> java junit.awtui.TestRunner FlorianJut

Diese Klasse setzt das Rahmenprogramm Junit Version 3.8 voraus.
Es laeuft *nicht* mit Junit Version 4.0 oder spaeteren Versionen.
------------------------------------------------------------------------ */
import junit.framework.Test;      // Eine Schnittstelle
import junit.framework.TestCase;  // Eine Test-Klasse
import junit.framework.TestSuite; // Eine Test-Klasse
import java.util.Arrays;

public class FlorianJut extends TestCase {
   // ---------------------------------------------------------------------
   static public Test suite() {
      // Alle parameterlosen Prozeduren dieser Klasse, deren Namen mit
      // "test" beginnen, werden zu einem TestSuite-Objekt zusammengefasst
      // und als Ergebnis geliefert:
      return new TestSuite(FlorianJut.class);
   } // suite
   // ---------------------------------------------------------------------
   public void test_blanksRaus_01() {
      assertEquals("",    Florian.blanksRaus(""));
      assertEquals("A",   Florian.blanksRaus("A"));
      assertEquals("ABC", Florian.blanksRaus("ABC"));
      assertEquals("ABC", Florian.blanksRaus("A B C"));
      assertEquals("ABC", Florian.blanksRaus(" ABC "));
      assertEquals("ABC", Florian.blanksRaus("  A  B  C"));
      assertEquals("",    Florian.blanksRaus("         "));
   }
   // ---------------------------------------------------------------------
   public void test_blanksRaus_02() {
      // Ein "Effizienztest" mit einem langen Blank-String. Wenn
      // blanksRaus uneffizient programmiert ist, kann dieser Test
      // (mit einem 2.5 GHz Pentium) mehr als eine Stunden dauern.
      final int LEN = 2 * 1000 * 1000;
      StringBuilder sb = new StringBuilder(LEN);
      for (int i=0; i<LEN; i++) sb.append(' ');
      String        st = Florian.blanksRaus(sb.toString());
      assertEquals("", st);
   }
   // ---------------------------------------------------------------------
   public void test_blanksRein_01() {
      assertEquals("",      Florian.blanksRein(""));
      assertEquals("A",     Florian.blanksRein("A"));
      assertEquals("A B",   Florian.blanksRein("AB"));
      assertEquals("A B C", Florian.blanksRein("ABC"));
      assertEquals("",      Florian.blanksRein(""));
      assertEquals(" ",     Florian.blanksRein(" "));
      assertEquals("   ",   Florian.blanksRein("  "));
      assertEquals("     ", Florian.blanksRein("   "));
   }
   // ---------------------------------------------------------------------
   public void test_blanksRein_02() {
      // Ein "Effizienztest" mit einem langen 'x'-String. Wenn
      // blanksRein uneffizient programmiert ist, kann dieser Test
      // (mit einem 2.5 GHz Pentium) ziemlich lange dauern.
      final int LEN = 2 * 1000 * 1000;
      StringBuilder sb = new StringBuilder(LEN);
      for (int i=0; i<LEN; i++) sb.append('x');
      String        st = Florian.blanksRein(sb.toString());
      assertEquals(2*LEN-1, st.length());
   }
   // ---------------------------------------------------------------------
   static public void main(String[] sonja) {
      // Alle Testfaelle werden ausgefuehrt:
      junit.awtui.TestRunner.run(FlorianJut.class);
   }
   // ---------------------------------------------------------------------
   // Eine Methode mit einem kurzen Namen:
   static void pln(Object ob) {System.out.println(ob);}
   // ---------------------------------------------------------------------
} // class FlorianJut
