// Datei InWortenJut.java
/* ------------------------------------------------------------------------
Diese Klasse dient zum Testen einer Klasse, die vier Methoden mit den
folgenden Profilen enthaelt:

String inWorten_1_9  (int n)
String inWorten_10_19(int n)
String inWorten_20_90(int n)
String inWorten_0_999(int n)

Der Name der zu testenden Klasse wird durch die unveraenderliche Variable
KLASSEN_NAME festgelegt (normalerweise: "InWorten", siehe unten).

Eine Reihung namens alleSollWerte am Ende dieser Datei enthaelt alle
deutschen, maennlichen Zahlworte fuer die Ganzzahlen von 0 bis 999.
---------------------------------------------------------------------------
Diese Klasse wurde mit dem Rahmenprogramm JUnit Version 3.8 erstellt.
Sie funktioniert *nicht* mit JUnit Version 4.0 oder spaeteren Versionen.

Diese Klasse kann man auf 2 Arten ausfuehren lassen:

1. Indem man das Programm InWortenJut aufruft (siehe die main-Methode).

2. Indem man in einem bash- oder DOS-Fenster das folgende Kommando eingibt:
> java junit.awtui.TestRunner InWortenJut
------------------------------------------------------------------------ */
import junit.framework.Test;      // Eine Schnittstelle
import junit.framework.TestCase;  // Eine Test-Klasse
import junit.framework.TestSuite; // Eine Test-Klasse
import java.util.Arrays;
import java.lang.reflect.Method;

public class InWortenJut extends TestCase {
   // ---------------------------------------------------------------------
   // Der volle Name der zu testenden Klasse:
   private static final String KLASSEN_NAME = "InWorten";
   // ---------------------------------------------------------------------
   static public Test suite() {
      // Alle parameterlosen Prozeduren dieser Klasse, deren Namen mit
      // "test" beginnen, werden zu einem TestSuite-Objekt zusammengefasst
      // und als Ergebnis geliefert:
      return new TestSuite(InWortenJut.class);
   } // suite
   // ---------------------------------------------------------------------
   public void test_inWorten_1_9() {
      final String METHODEN_NAME = "inWorten_1_9";

      try {
         Class<?> kob = Class.forName(KLASSEN_NAME);
         Method   met = kob.getMethod(METHODEN_NAME, Integer.TYPE);

         for (int n=1; n<=9; n++) {
            String ist = (String) met.invoke(null, n);
            assertEquals(alleSollWorte[n], ist);
         }

         // Ergebnisse bei falschen Parametern (0 und 10) werden getestet:
         String s1 = (String) met.invoke(null,  0);
         failWennNichtEnthaelt(s1, METHODEN_NAME);
         String s2 = (String) met.invoke(null, 10);
         failWennNichtEnthaelt(s2, METHODEN_NAME);
      } catch (Exception ex) {
         behandleAusnahmen(ex);
      }
   } // test_inWorten_1_9
   // ---------------------------------------------------------------------
   public void test_inWorten_10_19() {
      final String METHODEN_NAME = "inWorten_10_19";

      try {
         Class<?> kob = Class.forName(KLASSEN_NAME);
         Method   met = kob.getMethod(METHODEN_NAME, Integer.TYPE);

         for (int n=10; n<=19; n++) {
            String ist = (String) met.invoke(null, n);
            assertEquals(alleSollWorte[n], ist);
         }

         // Ergebnisse bei falschen Parametern (9 und 20) werden getestet:
         String s1 = (String) met.invoke(null,  9);
         failWennNichtEnthaelt(s1, METHODEN_NAME);
         String s2 = (String) met.invoke(null, 20);
         failWennNichtEnthaelt(s2, METHODEN_NAME);
      } catch (Exception ex) {
         behandleAusnahmen(ex);
      }
   } // test_inWorten_10_19
   // ---------------------------------------------------------------------
   public void test_inWorten_20_90() {
      final String METHODEN_NAME = "inWorten_20_90";

      try {
         Class<?> kob = Class.forName(KLASSEN_NAME);
         Method   met = kob.getMethod(METHODEN_NAME, Integer.TYPE);

         for (int n=2; n<=9; n++) {
            String ist = (String) met.invoke(null, n);
            assertEquals(alleSollWorte[n*10], ist);
         }

         // Ergebnisse bei falschen Parametern (1 und 10) werden getestet:
         String s1 = (String) met.invoke(null,  1);
         failWennNichtEnthaelt(s1, METHODEN_NAME);
         String s2 = (String) met.invoke(null, 10);
         failWennNichtEnthaelt(s2, METHODEN_NAME);
      } catch (Exception ex) {
         behandleAusnahmen(ex);
      }
   } // test_inWorten_20_90
   // ---------------------------------------------------------------------
   public void test_inWorten_0_999() {
      final String METHODEN_NAME = "inWorten_0_999";

      try {
         Class<?> kob = Class.forName(KLASSEN_NAME);
         Method   met = kob.getMethod(METHODEN_NAME, Integer.TYPE);

         for (int n=0; n<=999; n++) {
            String ist = (String) met.invoke(null, n);
            assertEquals(alleSollWorte[n], ist);
         }

         // Ergebnisse bei falschen Param. (-1 und 1000) werden getestet:
         String s1 = (String) met.invoke(null,  -1);
         failWennNichtEnthaelt(s1, METHODEN_NAME);
         String s2 = (String) met.invoke(null, 1000);
         failWennNichtEnthaelt(s2, METHODEN_NAME);
      } catch (Exception ex) {
         behandleAusnahmen(ex);
      }
   } // test_inWorten_0_999
   // ---------------------------------------------------------------------
   void behandleAusnahmen(Exception ex) {
      String msg = ex.getMessage();
      if (ex instanceof NoSuchMethodException) {
         String met = msg.substring(msg.lastIndexOf('.')+1);
         fail("Die Methode " + met + " muss noch implementiert werden!");
      } else if (ex instanceof ClassNotFoundException) {
         fail("Die Klasse "  + msg + " muss noch implementiert werden!");
      } else {
         throw new Error(ex);
      }
   } // behandleAusnahmen
   // ---------------------------------------------------------------------
   void failWennNichtEnthaelt(String s1, String s2) {
      // Prueft, ob der String s1 den String s2 enthaelt. Falls nicht,
      // wird die Methode fail (mit einer ausfuehrlichen Fehlermeldung als
      // Parameter) aufgerufen:
      if (s1.indexOf(s2) == -1) {
         fail("Fehlermeld. \"" + s1 + "\" enthaelt nicht \"" + s2 + "\"!");
      }
   } // failWennNichtEnthaelt
   // ---------------------------------------------------------------------
   static public void main(String[] sonja) {
      // Alle Testfaelle werden ausgefuehrt:
      junit.awtui.TestRunner.run(InWortenJut.class);
   } // main
   // ---------------------------------------------------------------------
   static String[] alleSollWorte = {
      "null",
      "ein",
      "zwei",
      "drei",
      "vier",
      "fuenf",
      "sechs",
      "sieben",
      "acht",
      "neun",
      "zehn",
      "elf",
      "zwoelf",
      "dreizehn",
      "vierzehn",
      "fuenfzehn",
      "sechzehn",
      "siebzehn",
      "achtzehn",
      "neunzehn",
      "zwanzig",
      "einundzwanzig",
      "zweiundzwanzig",
      "dreiundzwanzig",
      "vierundzwanzig",
      "fuenfundzwanzig",
      "sechsundzwanzig",
      "siebenundzwanzig",
      "achtundzwanzig",
      "neunundzwanzig",
      "dreissig",
      "einunddreissig",
      "zweiunddreissig",
      "dreiunddreissig",
      "vierunddreissig",
      "fuenfunddreissig",
      "sechsunddreissig",
      "siebenunddreissig",
      "achtunddreissig",
      "neununddreissig",
      "vierzig",
      "einundvierzig",
      "zweiundvierzig",
      "dreiundvierzig",
      "vierundvierzig",
      "fuenfundvierzig",
      "sechsundvierzig",
      "siebenundvierzig",
      "achtundvierzig",
      "neunundvierzig",
      "fuenfzig",
      "einundfuenfzig",
      "zweiundfuenfzig",
      "dreiundfuenfzig",
      "vierundfuenfzig",
      "fuenfundfuenfzig",
      "sechsundfuenfzig",
      "siebenundfuenfzig",
      "achtundfuenfzig",
      "neunundfuenfzig",
      "sechzig",
      "einundsechzig",
      "zweiundsechzig",
      "dreiundsechzig",
      "vierundsechzig",
      "fuenfundsechzig",
      "sechsundsechzig",
      "siebenundsechzig",
      "achtundsechzig",
      "neunundsechzig",
      "siebzig",
      "einundsiebzig",
      "zweiundsiebzig",
      "dreiundsiebzig",
      "vierundsiebzig",
      "fuenfundsiebzig",
      "sechsundsiebzig",
      "siebenundsiebzig",
      "achtundsiebzig",
      "neunundsiebzig",
      "achtzig",
      "einundachtzig",
      "zweiundachtzig",
      "dreiundachtzig",
      "vierundachtzig",
      "fuenfundachtzig",
      "sechsundachtzig",
      "siebenundachtzig",
      "achtundachtzig",
      "neunundachtzig",
      "neunzig",
      "einundneunzig",
      "zweiundneunzig",
      "dreiundneunzig",
      "vierundneunzig",
      "fuenfundneunzig",
      "sechsundneunzig",
      "siebenundneunzig",
      "achtundneunzig",
      "neunundneunzig",
      "einhundert",
      "einhundertundein",
      "einhundertundzwei",
      "einhundertunddrei",
      "einhundertundvier",
      "einhundertundfuenf",
      "einhundertundsechs",
      "einhundertundsieben",
      "einhundertundacht",
      "einhundertundneun",
      "einhundertundzehn",
      "einhundertundelf",
      "einhundertundzwoelf",
      "einhundertunddreizehn",
      "einhundertundvierzehn",
      "einhundertundfuenfzehn",
      "einhundertundsechzehn",
      "einhundertundsiebzehn",
      "einhundertundachtzehn",
      "einhundertundneunzehn",
      "einhundertundzwanzig",
      "einhundertundeinundzwanzig",
      "einhundertundzweiundzwanzig",
      "einhundertunddreiundzwanzig",
      "einhundertundvierundzwanzig",
      "einhundertundfuenfundzwanzig",
      "einhundertundsechsundzwanzig",
      "einhundertundsiebenundzwanzig",
      "einhundertundachtundzwanzig",
      "einhundertundneunundzwanzig",
      "einhundertunddreissig",
      "einhundertundeinunddreissig",
      "einhundertundzweiunddreissig",
      "einhundertunddreiunddreissig",
      "einhundertundvierunddreissig",
      "einhundertundfuenfunddreissig",
      "einhundertundsechsunddreissig",
      "einhundertundsiebenunddreissig",
      "einhundertundachtunddreissig",
      "einhundertundneununddreissig",
      "einhundertundvierzig",
      "einhundertundeinundvierzig",
      "einhundertundzweiundvierzig",
      "einhundertunddreiundvierzig",
      "einhundertundvierundvierzig",
      "einhundertundfuenfundvierzig",
      "einhundertundsechsundvierzig",
      "einhundertundsiebenundvierzig",
      "einhundertundachtundvierzig",
      "einhundertundneunundvierzig",
      "einhundertundfuenfzig",
      "einhundertundeinundfuenfzig",
      "einhundertundzweiundfuenfzig",
      "einhundertunddreiundfuenfzig",
      "einhundertundvierundfuenfzig",
      "einhundertundfuenfundfuenfzig",
      "einhundertundsechsundfuenfzig",
      "einhundertundsiebenundfuenfzig",
      "einhundertundachtundfuenfzig",
      "einhundertundneunundfuenfzig",
      "einhundertundsechzig",
      "einhundertundeinundsechzig",
      "einhundertundzweiundsechzig",
      "einhundertunddreiundsechzig",
      "einhundertundvierundsechzig",
      "einhundertundfuenfundsechzig",
      "einhundertundsechsundsechzig",
      "einhundertundsiebenundsechzig",
      "einhundertundachtundsechzig",
      "einhundertundneunundsechzig",
      "einhundertundsiebzig",
      "einhundertundeinundsiebzig",
      "einhundertundzweiundsiebzig",
      "einhundertunddreiundsiebzig",
      "einhundertundvierundsiebzig",
      "einhundertundfuenfundsiebzig",
      "einhundertundsechsundsiebzig",
      "einhundertundsiebenundsiebzig",
      "einhundertundachtundsiebzig",
      "einhundertundneunundsiebzig",
      "einhundertundachtzig",
      "einhundertundeinundachtzig",
      "einhundertundzweiundachtzig",
      "einhundertunddreiundachtzig",
      "einhundertundvierundachtzig",
      "einhundertundfuenfundachtzig",
      "einhundertundsechsundachtzig",
      "einhundertundsiebenundachtzig",
      "einhundertundachtundachtzig",
      "einhundertundneunundachtzig",
      "einhundertundneunzig",
      "einhundertundeinundneunzig",
      "einhundertundzweiundneunzig",
      "einhundertunddreiundneunzig",
      "einhundertundvierundneunzig",
      "einhundertundfuenfundneunzig",
      "einhundertundsechsundneunzig",
      "einhundertundsiebenundneunzig",
      "einhundertundachtundneunzig",
      "einhundertundneunundneunzig",
      "zweihundert",
      "zweihundertundein",
      "zweihundertundzwei",
      "zweihundertunddrei",
      "zweihundertundvier",
      "zweihundertundfuenf",
      "zweihundertundsechs",
      "zweihundertundsieben",
      "zweihundertundacht",
      "zweihundertundneun",
      "zweihundertundzehn",
      "zweihundertundelf",
      "zweihundertundzwoelf",
      "zweihundertunddreizehn",
      "zweihundertundvierzehn",
      "zweihundertundfuenfzehn",
      "zweihundertundsechzehn",
      "zweihundertundsiebzehn",
      "zweihundertundachtzehn",
      "zweihundertundneunzehn",
      "zweihundertundzwanzig",
      "zweihundertundeinundzwanzig",
      "zweihundertundzweiundzwanzig",
      "zweihundertunddreiundzwanzig",
      "zweihundertundvierundzwanzig",
      "zweihundertundfuenfundzwanzig",
      "zweihundertundsechsundzwanzig",
      "zweihundertundsiebenundzwanzig",
      "zweihundertundachtundzwanzig",
      "zweihundertundneunundzwanzig",
      "zweihundertunddreissig",
      "zweihundertundeinunddreissig",
      "zweihundertundzweiunddreissig",
      "zweihundertunddreiunddreissig",
      "zweihundertundvierunddreissig",
      "zweihundertundfuenfunddreissig",
      "zweihundertundsechsunddreissig",
      "zweihundertundsiebenunddreissig",
      "zweihundertundachtunddreissig",
      "zweihundertundneununddreissig",
      "zweihundertundvierzig",
      "zweihundertundeinundvierzig",
      "zweihundertundzweiundvierzig",
      "zweihundertunddreiundvierzig",
      "zweihundertundvierundvierzig",
      "zweihundertundfuenfundvierzig",
      "zweihundertundsechsundvierzig",
      "zweihundertundsiebenundvierzig",
      "zweihundertundachtundvierzig",
      "zweihundertundneunundvierzig",
      "zweihundertundfuenfzig",
      "zweihundertundeinundfuenfzig",
      "zweihundertundzweiundfuenfzig",
      "zweihundertunddreiundfuenfzig",
      "zweihundertundvierundfuenfzig",
      "zweihundertundfuenfundfuenfzig",
      "zweihundertundsechsundfuenfzig",
      "zweihundertundsiebenundfuenfzig",
      "zweihundertundachtundfuenfzig",
      "zweihundertundneunundfuenfzig",
      "zweihundertundsechzig",
      "zweihundertundeinundsechzig",
      "zweihundertundzweiundsechzig",
      "zweihundertunddreiundsechzig",
      "zweihundertundvierundsechzig",
      "zweihundertundfuenfundsechzig",
      "zweihundertundsechsundsechzig",
      "zweihundertundsiebenundsechzig",
      "zweihundertundachtundsechzig",
      "zweihundertundneunundsechzig",
      "zweihundertundsiebzig",
      "zweihundertundeinundsiebzig",
      "zweihundertundzweiundsiebzig",
      "zweihundertunddreiundsiebzig",
      "zweihundertundvierundsiebzig",
      "zweihundertundfuenfundsiebzig",
      "zweihundertundsechsundsiebzig",
      "zweihundertundsiebenundsiebzig",
      "zweihundertundachtundsiebzig",
      "zweihundertundneunundsiebzig",
      "zweihundertundachtzig",
      "zweihundertundeinundachtzig",
      "zweihundertundzweiundachtzig",
      "zweihundertunddreiundachtzig",
      "zweihundertundvierundachtzig",
      "zweihundertundfuenfundachtzig",
      "zweihundertundsechsundachtzig",
      "zweihundertundsiebenundachtzig",
      "zweihundertundachtundachtzig",
      "zweihundertundneunundachtzig",
      "zweihundertundneunzig",
      "zweihundertundeinundneunzig",
      "zweihundertundzweiundneunzig",
      "zweihundertunddreiundneunzig",
      "zweihundertundvierundneunzig",
      "zweihundertundfuenfundneunzig",
      "zweihundertundsechsundneunzig",
      "zweihundertundsiebenundneunzig",
      "zweihundertundachtundneunzig",
      "zweihundertundneunundneunzig",
      "dreihundert",
      "dreihundertundein",
      "dreihundertundzwei",
      "dreihundertunddrei",
      "dreihundertundvier",
      "dreihundertundfuenf",
      "dreihundertundsechs",
      "dreihundertundsieben",
      "dreihundertundacht",
      "dreihundertundneun",
      "dreihundertundzehn",
      "dreihundertundelf",
      "dreihundertundzwoelf",
      "dreihundertunddreizehn",
      "dreihundertundvierzehn",
      "dreihundertundfuenfzehn",
      "dreihundertundsechzehn",
      "dreihundertundsiebzehn",
      "dreihundertundachtzehn",
      "dreihundertundneunzehn",
      "dreihundertundzwanzig",
      "dreihundertundeinundzwanzig",
      "dreihundertundzweiundzwanzig",
      "dreihundertunddreiundzwanzig",
      "dreihundertundvierundzwanzig",
      "dreihundertundfuenfundzwanzig",
      "dreihundertundsechsundzwanzig",
      "dreihundertundsiebenundzwanzig",
      "dreihundertundachtundzwanzig",
      "dreihundertundneunundzwanzig",
      "dreihundertunddreissig",
      "dreihundertundeinunddreissig",
      "dreihundertundzweiunddreissig",
      "dreihundertunddreiunddreissig",
      "dreihundertundvierunddreissig",
      "dreihundertundfuenfunddreissig",
      "dreihundertundsechsunddreissig",
      "dreihundertundsiebenunddreissig",
      "dreihundertundachtunddreissig",
      "dreihundertundneununddreissig",
      "dreihundertundvierzig",
      "dreihundertundeinundvierzig",
      "dreihundertundzweiundvierzig",
      "dreihundertunddreiundvierzig",
      "dreihundertundvierundvierzig",
      "dreihundertundfuenfundvierzig",
      "dreihundertundsechsundvierzig",
      "dreihundertundsiebenundvierzig",
      "dreihundertundachtundvierzig",
      "dreihundertundneunundvierzig",
      "dreihundertundfuenfzig",
      "dreihundertundeinundfuenfzig",
      "dreihundertundzweiundfuenfzig",
      "dreihundertunddreiundfuenfzig",
      "dreihundertundvierundfuenfzig",
      "dreihundertundfuenfundfuenfzig",
      "dreihundertundsechsundfuenfzig",
      "dreihundertundsiebenundfuenfzig",
      "dreihundertundachtundfuenfzig",
      "dreihundertundneunundfuenfzig",
      "dreihundertundsechzig",
      "dreihundertundeinundsechzig",
      "dreihundertundzweiundsechzig",
      "dreihundertunddreiundsechzig",
      "dreihundertundvierundsechzig",
      "dreihundertundfuenfundsechzig",
      "dreihundertundsechsundsechzig",
      "dreihundertundsiebenundsechzig",
      "dreihundertundachtundsechzig",
      "dreihundertundneunundsechzig",
      "dreihundertundsiebzig",
      "dreihundertundeinundsiebzig",
      "dreihundertundzweiundsiebzig",
      "dreihundertunddreiundsiebzig",
      "dreihundertundvierundsiebzig",
      "dreihundertundfuenfundsiebzig",
      "dreihundertundsechsundsiebzig",
      "dreihundertundsiebenundsiebzig",
      "dreihundertundachtundsiebzig",
      "dreihundertundneunundsiebzig",
      "dreihundertundachtzig",
      "dreihundertundeinundachtzig",
      "dreihundertundzweiundachtzig",
      "dreihundertunddreiundachtzig",
      "dreihundertundvierundachtzig",
      "dreihundertundfuenfundachtzig",
      "dreihundertundsechsundachtzig",
      "dreihundertundsiebenundachtzig",
      "dreihundertundachtundachtzig",
      "dreihundertundneunundachtzig",
      "dreihundertundneunzig",
      "dreihundertundeinundneunzig",
      "dreihundertundzweiundneunzig",
      "dreihundertunddreiundneunzig",
      "dreihundertundvierundneunzig",
      "dreihundertundfuenfundneunzig",
      "dreihundertundsechsundneunzig",
      "dreihundertundsiebenundneunzig",
      "dreihundertundachtundneunzig",
      "dreihundertundneunundneunzig",
      "vierhundert",
      "vierhundertundein",
      "vierhundertundzwei",
      "vierhundertunddrei",
      "vierhundertundvier",
      "vierhundertundfuenf",
      "vierhundertundsechs",
      "vierhundertundsieben",
      "vierhundertundacht",
      "vierhundertundneun",
      "vierhundertundzehn",
      "vierhundertundelf",
      "vierhundertundzwoelf",
      "vierhundertunddreizehn",
      "vierhundertundvierzehn",
      "vierhundertundfuenfzehn",
      "vierhundertundsechzehn",
      "vierhundertundsiebzehn",
      "vierhundertundachtzehn",
      "vierhundertundneunzehn",
      "vierhundertundzwanzig",
      "vierhundertundeinundzwanzig",
      "vierhundertundzweiundzwanzig",
      "vierhundertunddreiundzwanzig",
      "vierhundertundvierundzwanzig",
      "vierhundertundfuenfundzwanzig",
      "vierhundertundsechsundzwanzig",
      "vierhundertundsiebenundzwanzig",
      "vierhundertundachtundzwanzig",
      "vierhundertundneunundzwanzig",
      "vierhundertunddreissig",
      "vierhundertundeinunddreissig",
      "vierhundertundzweiunddreissig",
      "vierhundertunddreiunddreissig",
      "vierhundertundvierunddreissig",
      "vierhundertundfuenfunddreissig",
      "vierhundertundsechsunddreissig",
      "vierhundertundsiebenunddreissig",
      "vierhundertundachtunddreissig",
      "vierhundertundneununddreissig",
      "vierhundertundvierzig",
      "vierhundertundeinundvierzig",
      "vierhundertundzweiundvierzig",
      "vierhundertunddreiundvierzig",
      "vierhundertundvierundvierzig",
      "vierhundertundfuenfundvierzig",
      "vierhundertundsechsundvierzig",
      "vierhundertundsiebenundvierzig",
      "vierhundertundachtundvierzig",
      "vierhundertundneunundvierzig",
      "vierhundertundfuenfzig",
      "vierhundertundeinundfuenfzig",
      "vierhundertundzweiundfuenfzig",
      "vierhundertunddreiundfuenfzig",
      "vierhundertundvierundfuenfzig",
      "vierhundertundfuenfundfuenfzig",
      "vierhundertundsechsundfuenfzig",
      "vierhundertundsiebenundfuenfzig",
      "vierhundertundachtundfuenfzig",
      "vierhundertundneunundfuenfzig",
      "vierhundertundsechzig",
      "vierhundertundeinundsechzig",
      "vierhundertundzweiundsechzig",
      "vierhundertunddreiundsechzig",
      "vierhundertundvierundsechzig",
      "vierhundertundfuenfundsechzig",
      "vierhundertundsechsundsechzig",
      "vierhundertundsiebenundsechzig",
      "vierhundertundachtundsechzig",
      "vierhundertundneunundsechzig",
      "vierhundertundsiebzig",
      "vierhundertundeinundsiebzig",
      "vierhundertundzweiundsiebzig",
      "vierhundertunddreiundsiebzig",
      "vierhundertundvierundsiebzig",
      "vierhundertundfuenfundsiebzig",
      "vierhundertundsechsundsiebzig",
      "vierhundertundsiebenundsiebzig",
      "vierhundertundachtundsiebzig",
      "vierhundertundneunundsiebzig",
      "vierhundertundachtzig",
      "vierhundertundeinundachtzig",
      "vierhundertundzweiundachtzig",
      "vierhundertunddreiundachtzig",
      "vierhundertundvierundachtzig",
      "vierhundertundfuenfundachtzig",
      "vierhundertundsechsundachtzig",
      "vierhundertundsiebenundachtzig",
      "vierhundertundachtundachtzig",
      "vierhundertundneunundachtzig",
      "vierhundertundneunzig",
      "vierhundertundeinundneunzig",
      "vierhundertundzweiundneunzig",
      "vierhundertunddreiundneunzig",
      "vierhundertundvierundneunzig",
      "vierhundertundfuenfundneunzig",
      "vierhundertundsechsundneunzig",
      "vierhundertundsiebenundneunzig",
      "vierhundertundachtundneunzig",
      "vierhundertundneunundneunzig",
      "fuenfhundert",
      "fuenfhundertundein",
      "fuenfhundertundzwei",
      "fuenfhundertunddrei",
      "fuenfhundertundvier",
      "fuenfhundertundfuenf",
      "fuenfhundertundsechs",
      "fuenfhundertundsieben",
      "fuenfhundertundacht",
      "fuenfhundertundneun",
      "fuenfhundertundzehn",
      "fuenfhundertundelf",
      "fuenfhundertundzwoelf",
      "fuenfhundertunddreizehn",
      "fuenfhundertundvierzehn",
      "fuenfhundertundfuenfzehn",
      "fuenfhundertundsechzehn",
      "fuenfhundertundsiebzehn",
      "fuenfhundertundachtzehn",
      "fuenfhundertundneunzehn",
      "fuenfhundertundzwanzig",
      "fuenfhundertundeinundzwanzig",
      "fuenfhundertundzweiundzwanzig",
      "fuenfhundertunddreiundzwanzig",
      "fuenfhundertundvierundzwanzig",
      "fuenfhundertundfuenfundzwanzig",
      "fuenfhundertundsechsundzwanzig",
      "fuenfhundertundsiebenundzwanzig",
      "fuenfhundertundachtundzwanzig",
      "fuenfhundertundneunundzwanzig",
      "fuenfhundertunddreissig",
      "fuenfhundertundeinunddreissig",
      "fuenfhundertundzweiunddreissig",
      "fuenfhundertunddreiunddreissig",
      "fuenfhundertundvierunddreissig",
      "fuenfhundertundfuenfunddreissig",
      "fuenfhundertundsechsunddreissig",
      "fuenfhundertundsiebenunddreissig",
      "fuenfhundertundachtunddreissig",
      "fuenfhundertundneununddreissig",
      "fuenfhundertundvierzig",
      "fuenfhundertundeinundvierzig",
      "fuenfhundertundzweiundvierzig",
      "fuenfhundertunddreiundvierzig",
      "fuenfhundertundvierundvierzig",
      "fuenfhundertundfuenfundvierzig",
      "fuenfhundertundsechsundvierzig",
      "fuenfhundertundsiebenundvierzig",
      "fuenfhundertundachtundvierzig",
      "fuenfhundertundneunundvierzig",
      "fuenfhundertundfuenfzig",
      "fuenfhundertundeinundfuenfzig",
      "fuenfhundertundzweiundfuenfzig",
      "fuenfhundertunddreiundfuenfzig",
      "fuenfhundertundvierundfuenfzig",
      "fuenfhundertundfuenfundfuenfzig",
      "fuenfhundertundsechsundfuenfzig",
      "fuenfhundertundsiebenundfuenfzig",
      "fuenfhundertundachtundfuenfzig",
      "fuenfhundertundneunundfuenfzig",
      "fuenfhundertundsechzig",
      "fuenfhundertundeinundsechzig",
      "fuenfhundertundzweiundsechzig",
      "fuenfhundertunddreiundsechzig",
      "fuenfhundertundvierundsechzig",
      "fuenfhundertundfuenfundsechzig",
      "fuenfhundertundsechsundsechzig",
      "fuenfhundertundsiebenundsechzig",
      "fuenfhundertundachtundsechzig",
      "fuenfhundertundneunundsechzig",
      "fuenfhundertundsiebzig",
      "fuenfhundertundeinundsiebzig",
      "fuenfhundertundzweiundsiebzig",
      "fuenfhundertunddreiundsiebzig",
      "fuenfhundertundvierundsiebzig",
      "fuenfhundertundfuenfundsiebzig",
      "fuenfhundertundsechsundsiebzig",
      "fuenfhundertundsiebenundsiebzig",
      "fuenfhundertundachtundsiebzig",
      "fuenfhundertundneunundsiebzig",
      "fuenfhundertundachtzig",
      "fuenfhundertundeinundachtzig",
      "fuenfhundertundzweiundachtzig",
      "fuenfhundertunddreiundachtzig",
      "fuenfhundertundvierundachtzig",
      "fuenfhundertundfuenfundachtzig",
      "fuenfhundertundsechsundachtzig",
      "fuenfhundertundsiebenundachtzig",
      "fuenfhundertundachtundachtzig",
      "fuenfhundertundneunundachtzig",
      "fuenfhundertundneunzig",
      "fuenfhundertundeinundneunzig",
      "fuenfhundertundzweiundneunzig",
      "fuenfhundertunddreiundneunzig",
      "fuenfhundertundvierundneunzig",
      "fuenfhundertundfuenfundneunzig",
      "fuenfhundertundsechsundneunzig",
      "fuenfhundertundsiebenundneunzig",
      "fuenfhundertundachtundneunzig",
      "fuenfhundertundneunundneunzig",
      "sechshundert",
      "sechshundertundein",
      "sechshundertundzwei",
      "sechshundertunddrei",
      "sechshundertundvier",
      "sechshundertundfuenf",
      "sechshundertundsechs",
      "sechshundertundsieben",
      "sechshundertundacht",
      "sechshundertundneun",
      "sechshundertundzehn",
      "sechshundertundelf",
      "sechshundertundzwoelf",
      "sechshundertunddreizehn",
      "sechshundertundvierzehn",
      "sechshundertundfuenfzehn",
      "sechshundertundsechzehn",
      "sechshundertundsiebzehn",
      "sechshundertundachtzehn",
      "sechshundertundneunzehn",
      "sechshundertundzwanzig",
      "sechshundertundeinundzwanzig",
      "sechshundertundzweiundzwanzig",
      "sechshundertunddreiundzwanzig",
      "sechshundertundvierundzwanzig",
      "sechshundertundfuenfundzwanzig",
      "sechshundertundsechsundzwanzig",
      "sechshundertundsiebenundzwanzig",
      "sechshundertundachtundzwanzig",
      "sechshundertundneunundzwanzig",
      "sechshundertunddreissig",
      "sechshundertundeinunddreissig",
      "sechshundertundzweiunddreissig",
      "sechshundertunddreiunddreissig",
      "sechshundertundvierunddreissig",
      "sechshundertundfuenfunddreissig",
      "sechshundertundsechsunddreissig",
      "sechshundertundsiebenunddreissig",
      "sechshundertundachtunddreissig",
      "sechshundertundneununddreissig",
      "sechshundertundvierzig",
      "sechshundertundeinundvierzig",
      "sechshundertundzweiundvierzig",
      "sechshundertunddreiundvierzig",
      "sechshundertundvierundvierzig",
      "sechshundertundfuenfundvierzig",
      "sechshundertundsechsundvierzig",
      "sechshundertundsiebenundvierzig",
      "sechshundertundachtundvierzig",
      "sechshundertundneunundvierzig",
      "sechshundertundfuenfzig",
      "sechshundertundeinundfuenfzig",
      "sechshundertundzweiundfuenfzig",
      "sechshundertunddreiundfuenfzig",
      "sechshundertundvierundfuenfzig",
      "sechshundertundfuenfundfuenfzig",
      "sechshundertundsechsundfuenfzig",
      "sechshundertundsiebenundfuenfzig",
      "sechshundertundachtundfuenfzig",
      "sechshundertundneunundfuenfzig",
      "sechshundertundsechzig",
      "sechshundertundeinundsechzig",
      "sechshundertundzweiundsechzig",
      "sechshundertunddreiundsechzig",
      "sechshundertundvierundsechzig",
      "sechshundertundfuenfundsechzig",
      "sechshundertundsechsundsechzig",
      "sechshundertundsiebenundsechzig",
      "sechshundertundachtundsechzig",
      "sechshundertundneunundsechzig",
      "sechshundertundsiebzig",
      "sechshundertundeinundsiebzig",
      "sechshundertundzweiundsiebzig",
      "sechshundertunddreiundsiebzig",
      "sechshundertundvierundsiebzig",
      "sechshundertundfuenfundsiebzig",
      "sechshundertundsechsundsiebzig",
      "sechshundertundsiebenundsiebzig",
      "sechshundertundachtundsiebzig",
      "sechshundertundneunundsiebzig",
      "sechshundertundachtzig",
      "sechshundertundeinundachtzig",
      "sechshundertundzweiundachtzig",
      "sechshundertunddreiundachtzig",
      "sechshundertundvierundachtzig",
      "sechshundertundfuenfundachtzig",
      "sechshundertundsechsundachtzig",
      "sechshundertundsiebenundachtzig",
      "sechshundertundachtundachtzig",
      "sechshundertundneunundachtzig",
      "sechshundertundneunzig",
      "sechshundertundeinundneunzig",
      "sechshundertundzweiundneunzig",
      "sechshundertunddreiundneunzig",
      "sechshundertundvierundneunzig",
      "sechshundertundfuenfundneunzig",
      "sechshundertundsechsundneunzig",
      "sechshundertundsiebenundneunzig",
      "sechshundertundachtundneunzig",
      "sechshundertundneunundneunzig",
      "siebenhundert",
      "siebenhundertundein",
      "siebenhundertundzwei",
      "siebenhundertunddrei",
      "siebenhundertundvier",
      "siebenhundertundfuenf",
      "siebenhundertundsechs",
      "siebenhundertundsieben",
      "siebenhundertundacht",
      "siebenhundertundneun",
      "siebenhundertundzehn",
      "siebenhundertundelf",
      "siebenhundertundzwoelf",
      "siebenhundertunddreizehn",
      "siebenhundertundvierzehn",
      "siebenhundertundfuenfzehn",
      "siebenhundertundsechzehn",
      "siebenhundertundsiebzehn",
      "siebenhundertundachtzehn",
      "siebenhundertundneunzehn",
      "siebenhundertundzwanzig",
      "siebenhundertundeinundzwanzig",
      "siebenhundertundzweiundzwanzig",
      "siebenhundertunddreiundzwanzig",
      "siebenhundertundvierundzwanzig",
      "siebenhundertundfuenfundzwanzig",
      "siebenhundertundsechsundzwanzig",
      "siebenhundertundsiebenundzwanzig",
      "siebenhundertundachtundzwanzig",
      "siebenhundertundneunundzwanzig",
      "siebenhundertunddreissig",
      "siebenhundertundeinunddreissig",
      "siebenhundertundzweiunddreissig",
      "siebenhundertunddreiunddreissig",
      "siebenhundertundvierunddreissig",
      "siebenhundertundfuenfunddreissig",
      "siebenhundertundsechsunddreissig",
      "siebenhundertundsiebenunddreissig",
      "siebenhundertundachtunddreissig",
      "siebenhundertundneununddreissig",
      "siebenhundertundvierzig",
      "siebenhundertundeinundvierzig",
      "siebenhundertundzweiundvierzig",
      "siebenhundertunddreiundvierzig",
      "siebenhundertundvierundvierzig",
      "siebenhundertundfuenfundvierzig",
      "siebenhundertundsechsundvierzig",
      "siebenhundertundsiebenundvierzig",
      "siebenhundertundachtundvierzig",
      "siebenhundertundneunundvierzig",
      "siebenhundertundfuenfzig",
      "siebenhundertundeinundfuenfzig",
      "siebenhundertundzweiundfuenfzig",
      "siebenhundertunddreiundfuenfzig",
      "siebenhundertundvierundfuenfzig",
      "siebenhundertundfuenfundfuenfzig",
      "siebenhundertundsechsundfuenfzig",
      "siebenhundertundsiebenundfuenfzig",
      "siebenhundertundachtundfuenfzig",
      "siebenhundertundneunundfuenfzig",
      "siebenhundertundsechzig",
      "siebenhundertundeinundsechzig",
      "siebenhundertundzweiundsechzig",
      "siebenhundertunddreiundsechzig",
      "siebenhundertundvierundsechzig",
      "siebenhundertundfuenfundsechzig",
      "siebenhundertundsechsundsechzig",
      "siebenhundertundsiebenundsechzig",
      "siebenhundertundachtundsechzig",
      "siebenhundertundneunundsechzig",
      "siebenhundertundsiebzig",
      "siebenhundertundeinundsiebzig",
      "siebenhundertundzweiundsiebzig",
      "siebenhundertunddreiundsiebzig",
      "siebenhundertundvierundsiebzig",
      "siebenhundertundfuenfundsiebzig",
      "siebenhundertundsechsundsiebzig",
      "siebenhundertundsiebenundsiebzig",
      "siebenhundertundachtundsiebzig",
      "siebenhundertundneunundsiebzig",
      "siebenhundertundachtzig",
      "siebenhundertundeinundachtzig",
      "siebenhundertundzweiundachtzig",
      "siebenhundertunddreiundachtzig",
      "siebenhundertundvierundachtzig",
      "siebenhundertundfuenfundachtzig",
      "siebenhundertundsechsundachtzig",
      "siebenhundertundsiebenundachtzig",
      "siebenhundertundachtundachtzig",
      "siebenhundertundneunundachtzig",
      "siebenhundertundneunzig",
      "siebenhundertundeinundneunzig",
      "siebenhundertundzweiundneunzig",
      "siebenhundertunddreiundneunzig",
      "siebenhundertundvierundneunzig",
      "siebenhundertundfuenfundneunzig",
      "siebenhundertundsechsundneunzig",
      "siebenhundertundsiebenundneunzig",
      "siebenhundertundachtundneunzig",
      "siebenhundertundneunundneunzig",
      "achthundert",
      "achthundertundein",
      "achthundertundzwei",
      "achthundertunddrei",
      "achthundertundvier",
      "achthundertundfuenf",
      "achthundertundsechs",
      "achthundertundsieben",
      "achthundertundacht",
      "achthundertundneun",
      "achthundertundzehn",
      "achthundertundelf",
      "achthundertundzwoelf",
      "achthundertunddreizehn",
      "achthundertundvierzehn",
      "achthundertundfuenfzehn",
      "achthundertundsechzehn",
      "achthundertundsiebzehn",
      "achthundertundachtzehn",
      "achthundertundneunzehn",
      "achthundertundzwanzig",
      "achthundertundeinundzwanzig",
      "achthundertundzweiundzwanzig",
      "achthundertunddreiundzwanzig",
      "achthundertundvierundzwanzig",
      "achthundertundfuenfundzwanzig",
      "achthundertundsechsundzwanzig",
      "achthundertundsiebenundzwanzig",
      "achthundertundachtundzwanzig",
      "achthundertundneunundzwanzig",
      "achthundertunddreissig",
      "achthundertundeinunddreissig",
      "achthundertundzweiunddreissig",
      "achthundertunddreiunddreissig",
      "achthundertundvierunddreissig",
      "achthundertundfuenfunddreissig",
      "achthundertundsechsunddreissig",
      "achthundertundsiebenunddreissig",
      "achthundertundachtunddreissig",
      "achthundertundneununddreissig",
      "achthundertundvierzig",
      "achthundertundeinundvierzig",
      "achthundertundzweiundvierzig",
      "achthundertunddreiundvierzig",
      "achthundertundvierundvierzig",
      "achthundertundfuenfundvierzig",
      "achthundertundsechsundvierzig",
      "achthundertundsiebenundvierzig",
      "achthundertundachtundvierzig",
      "achthundertundneunundvierzig",
      "achthundertundfuenfzig",
      "achthundertundeinundfuenfzig",
      "achthundertundzweiundfuenfzig",
      "achthundertunddreiundfuenfzig",
      "achthundertundvierundfuenfzig",
      "achthundertundfuenfundfuenfzig",
      "achthundertundsechsundfuenfzig",
      "achthundertundsiebenundfuenfzig",
      "achthundertundachtundfuenfzig",
      "achthundertundneunundfuenfzig",
      "achthundertundsechzig",
      "achthundertundeinundsechzig",
      "achthundertundzweiundsechzig",
      "achthundertunddreiundsechzig",
      "achthundertundvierundsechzig",
      "achthundertundfuenfundsechzig",
      "achthundertundsechsundsechzig",
      "achthundertundsiebenundsechzig",
      "achthundertundachtundsechzig",
      "achthundertundneunundsechzig",
      "achthundertundsiebzig",
      "achthundertundeinundsiebzig",
      "achthundertundzweiundsiebzig",
      "achthundertunddreiundsiebzig",
      "achthundertundvierundsiebzig",
      "achthundertundfuenfundsiebzig",
      "achthundertundsechsundsiebzig",
      "achthundertundsiebenundsiebzig",
      "achthundertundachtundsiebzig",
      "achthundertundneunundsiebzig",
      "achthundertundachtzig",
      "achthundertundeinundachtzig",
      "achthundertundzweiundachtzig",
      "achthundertunddreiundachtzig",
      "achthundertundvierundachtzig",
      "achthundertundfuenfundachtzig",
      "achthundertundsechsundachtzig",
      "achthundertundsiebenundachtzig",
      "achthundertundachtundachtzig",
      "achthundertundneunundachtzig",
      "achthundertundneunzig",
      "achthundertundeinundneunzig",
      "achthundertundzweiundneunzig",
      "achthundertunddreiundneunzig",
      "achthundertundvierundneunzig",
      "achthundertundfuenfundneunzig",
      "achthundertundsechsundneunzig",
      "achthundertundsiebenundneunzig",
      "achthundertundachtundneunzig",
      "achthundertundneunundneunzig",
      "neunhundert",
      "neunhundertundein",
      "neunhundertundzwei",
      "neunhundertunddrei",
      "neunhundertundvier",
      "neunhundertundfuenf",
      "neunhundertundsechs",
      "neunhundertundsieben",
      "neunhundertundacht",
      "neunhundertundneun",
      "neunhundertundzehn",
      "neunhundertundelf",
      "neunhundertundzwoelf",
      "neunhundertunddreizehn",
      "neunhundertundvierzehn",
      "neunhundertundfuenfzehn",
      "neunhundertundsechzehn",
      "neunhundertundsiebzehn",
      "neunhundertundachtzehn",
      "neunhundertundneunzehn",
      "neunhundertundzwanzig",
      "neunhundertundeinundzwanzig",
      "neunhundertundzweiundzwanzig",
      "neunhundertunddreiundzwanzig",
      "neunhundertundvierundzwanzig",
      "neunhundertundfuenfundzwanzig",
      "neunhundertundsechsundzwanzig",
      "neunhundertundsiebenundzwanzig",
      "neunhundertundachtundzwanzig",
      "neunhundertundneunundzwanzig",
      "neunhundertunddreissig",
      "neunhundertundeinunddreissig",
      "neunhundertundzweiunddreissig",
      "neunhundertunddreiunddreissig",
      "neunhundertundvierunddreissig",
      "neunhundertundfuenfunddreissig",
      "neunhundertundsechsunddreissig",
      "neunhundertundsiebenunddreissig",
      "neunhundertundachtunddreissig",
      "neunhundertundneununddreissig",
      "neunhundertundvierzig",
      "neunhundertundeinundvierzig",
      "neunhundertundzweiundvierzig",
      "neunhundertunddreiundvierzig",
      "neunhundertundvierundvierzig",
      "neunhundertundfuenfundvierzig",
      "neunhundertundsechsundvierzig",
      "neunhundertundsiebenundvierzig",
      "neunhundertundachtundvierzig",
      "neunhundertundneunundvierzig",
      "neunhundertundfuenfzig",
      "neunhundertundeinundfuenfzig",
      "neunhundertundzweiundfuenfzig",
      "neunhundertunddreiundfuenfzig",
      "neunhundertundvierundfuenfzig",
      "neunhundertundfuenfundfuenfzig",
      "neunhundertundsechsundfuenfzig",
      "neunhundertundsiebenundfuenfzig",
      "neunhundertundachtundfuenfzig",
      "neunhundertundneunundfuenfzig",
      "neunhundertundsechzig",
      "neunhundertundeinundsechzig",
      "neunhundertundzweiundsechzig",
      "neunhundertunddreiundsechzig",
      "neunhundertundvierundsechzig",
      "neunhundertundfuenfundsechzig",
      "neunhundertundsechsundsechzig",
      "neunhundertundsiebenundsechzig",
      "neunhundertundachtundsechzig",
      "neunhundertundneunundsechzig",
      "neunhundertundsiebzig",
      "neunhundertundeinundsiebzig",
      "neunhundertundzweiundsiebzig",
      "neunhundertunddreiundsiebzig",
      "neunhundertundvierundsiebzig",
      "neunhundertundfuenfundsiebzig",
      "neunhundertundsechsundsiebzig",
      "neunhundertundsiebenundsiebzig",
      "neunhundertundachtundsiebzig",
      "neunhundertundneunundsiebzig",
      "neunhundertundachtzig",
      "neunhundertundeinundachtzig",
      "neunhundertundzweiundachtzig",
      "neunhundertunddreiundachtzig",
      "neunhundertundvierundachtzig",
      "neunhundertundfuenfundachtzig",
      "neunhundertundsechsundachtzig",
      "neunhundertundsiebenundachtzig",
      "neunhundertundachtundachtzig",
      "neunhundertundneunundachtzig",
      "neunhundertundneunzig",
      "neunhundertundeinundneunzig",
      "neunhundertundzweiundneunzig",
      "neunhundertunddreiundneunzig",
      "neunhundertundvierundneunzig",
      "neunhundertundfuenfundneunzig",
      "neunhundertundsechsundneunzig",
      "neunhundertundsiebenundneunzig",
      "neunhundertundachtundneunzig",
      "neunhundertundneunundneunzig",
   }; // alleSollWorte
   // ---------------------------------------------------------------------
   // Eine Methode mit einem kurzen Namen:
   static void pln(Object ob) {System.out.println(ob);}
} // class InWortenJut
