// Datei SchleifenJut.java
/* ------------------------------------------------------------------------
Diese Klasse dient zum Testen der Klasse Schleifen.
---------------------------------------------------------------------------
Diese Klasse dient zum Testen einer Klasse, die folgende Methoden enthaelt:
zeile, spalte, schach01 bis schach05, gitter.
Der Name der Klasse wird durch die Variable KLASSEN_NAME festgelegt (s.u.).

Diese Klasse kann man auf 2 Arten ausfuehren lassen:

1. Indem man das Programm SchleifenJut aufruft (siehe die main-Methode).

2. Indem man in einem bash- oder DOS-Fenster das folgende Kommando eingibt:
> java junit.awtui.TestRunner SchleifenJut

Diese Klasse setzt das Rahmenprogramm Junit Version 3.8 voraus.
Es laeuft *nicht* mit Junit Version 4.0 oder spaeteren Versionen.
------------------------------------------------------------------------ */
import junit.framework.Test;      // Eine Schnittstelle
import junit.framework.TestCase;  // Eine Test-Klasse
import junit.framework.TestSuite; // Eine Test-Klasse
import java.util.Arrays;
import java.lang.reflect.Method;

public class SchleifenJut extends TestCase {
   // ---------------------------------------------------------------------
   // Der Name der zu testenden Klasse:
   final String KLASSEN_NAME = "Schleifen";
   // ---------------------------------------------------------------------
   static public Test suite() {
      // Alle parameterlosen Prozeduren dieser Klasse, deren Namen mit
      // "test" beginnen, werden zu einem TestSuite-Objekt zusammengefasst
      // und als Ergebnis geliefert:
      return new TestSuite(SchleifenJut.class);
   } // suite
   // ---------------------------------------------------------------------
   String soll01 =
      "A1 A2 A3 A4 A5 A6 A7 A8 \n" +
      "B1 B2 B3 B4 B5 B6 B7 B8 \n" +
      "C1 C2 C3 C4 C5 C6 C7 C8 \n" +
      "D1 D2 D3 D4 D5 D6 D7 D8 \n" +
      "E1 E2 E3 E4 E5 E6 E7 E8 \n" +
      "F1 F2 F3 F4 F5 F6 F7 F8 \n" +
      "G1 G2 G3 G4 G5 G6 G7 G8 \n" +
      "H1 H2 H3 H4 H5 H6 H7 H8 \n"
   ;

   String soll02 =
      "H1 G1 F1 E1 D1 C1 B1 A1 \n" +
      "H2 G2 F2 E2 D2 C2 B2 A2 \n" +
      "H3 G3 F3 E3 D3 C3 B3 A3 \n" +
      "H4 G4 F4 E4 D4 C4 B4 A4 \n" +
      "H5 G5 F5 E5 D5 C5 B5 A5 \n" +
      "H6 G6 F6 E6 D6 C6 B6 A6 \n" +
      "H7 G7 F7 E7 D7 C7 B7 A7 \n" +
      "H8 G8 F8 E8 D8 C8 B8 A8 \n"
   ;

   String soll03 =
      "H8 H7 H6 H5 H4 H3 H2 H1 \n" +
      "G8 G7 G6 G5 G4 G3 G2 G1 \n" +
      "F8 F7 F6 F5 F4 F3 F2 F1 \n" +
      "E8 E7 E6 E5 E4 E3 E2 E1 \n" +
      "D8 D7 D6 D5 D4 D3 D2 D1 \n" +
      "C8 C7 C6 C5 C4 C3 C2 C1 \n" +
      "B8 B7 B6 B5 B4 B3 B2 B1 \n" +
      "A8 A7 A6 A5 A4 A3 A2 A1 \n"
   ;

   String soll04 =
      "A8 B8 C8 D8 E8 F8 G8 H8 \n" +
      "A7 B7 C7 D7 E7 F7 G7 H7 \n" +
      "A6 B6 C6 D6 E6 F6 G6 H6 \n" +
      "A5 B5 C5 D5 E5 F5 G5 H5 \n" +
      "A4 B4 C4 D4 E4 F4 G4 H4 \n" +
      "A3 B3 C3 D3 E3 F3 G3 H3 \n" +
      "A2 B2 C2 D2 E2 F2 G2 H2 \n" +
      "A1 B1 C1 D1 E1 F1 G1 H1 \n"
   ;

   // ---------------------------------------------------------------------
   public void test_zeile() {
      String soll = "A1 A2 A3 A4 A5 A6 A7 A8 \n";
      String ist  = rufeAuf("zeile");

      assertEquals(soll.length(), ist.length());
      assertEquals(soll, ist);
   } // test_zeile
   // ---------------------------------------------------------------------
   public void test_spalte() {
      String soll = "A1 \n" +
                    "B1 \n" +
                    "C1 \n" +
                    "D1 \n" +
                    "E1 \n" +
                    "F1 \n" +
                    "G1 \n" +
                    "H1 \n";
      String ist  = rufeAuf("spalte");

      assertEquals(soll.length(), ist.length());
      assertEquals(soll, ist);
   } // test_spalte
   // ---------------------------------------------------------------------
   public void test_schach01() {
      String ist01 = rufeAuf("schach01");

      assertEquals(soll01.length(), ist01.length());
      assertEquals(soll01, ist01);
   } // test_schach01
   // ---------------------------------------------------------------------
   public void test_schach02() {
      String ist02 = rufeAuf("schach02");

      assertEquals(soll02.length(), ist02.length());
      assertEquals(soll02, ist02);
   } // test_schach02
   // ---------------------------------------------------------------------
   public void test_schach03() {
      String ist03 = rufeAuf("schach03");

      assertEquals(soll03.length(), ist03.length());
      assertEquals(soll03, ist03);
   } // test_schach01
   // ---------------------------------------------------------------------
   public void test_schach04() {
      String ist04 = rufeAuf("schach04");

      assertEquals(soll04.length(), ist04.length());
      assertEquals(soll04, ist04);
   } // test_schach04
   // ---------------------------------------------------------------------
   public void test_schach05_01() {
      String ist01 = rufeAuf("schach05", "ABCDEFGH", "12345678");

      assertEquals(soll01.length(), ist01.length());
      assertEquals(soll01, ist01);
   } // test_schach05_01
   // ---------------------------------------------------------------------
   public void test_schach05_02() {
      String ist02 = rufeAuf("schach05", "12345678", "HGFEDCBA");

      assertEquals(soll02.length(), ist02.length());
      assertEquals(soll02, ist02);
   } // test_schach05_02
   // ---------------------------------------------------------------------
   public void test_schach05_03() {
      String ist03 = rufeAuf("schach05", "HGFEDCBA", "87654321");

      assertEquals(soll03.length(), ist03.length());
      assertEquals(soll03, ist03);
   } // test_schach05_03
   // ---------------------------------------------------------------------
   public void test_schach05_04() {
      String ist04 = rufeAuf("schach05", "87654321", "ABCDEFGH");

      assertEquals(soll04.length(), ist04.length());
      assertEquals(soll04, ist04);
   } // test_schach05_04
   // ---------------------------------------------------------------------
   public void test_schach05_05() {
      String soll05 =
         "A1 B1 C1 D1 E1 F1 G1 H1 I1 J1 K1 L1 M1 N1 O1 \n" +
         "A2 B2 C2 D2 E2 F2 G2 H2 I2 J2 K2 L2 M2 N2 O2 \n" +
         "A3 B3 C3 D3 E3 F3 G3 H3 I3 J3 K3 L3 M3 N3 O3 \n"
      ;

      String ist05 = rufeAuf("schach05", "123", "ABCDEFGHIJKLMNO");

      assertEquals(soll05.length(), ist05.length());
      assertEquals(soll05, ist05);
   } // test_schach05_05
   // ---------------------------------------------------------------------
   public void test_schach05_06() {
      String soll06 =
         "A1 A2 A3 \n" +
         "B1 B2 B3 \n" +
         "C1 C2 C3 \n" +
         "D1 D2 D3 \n" +
         "E1 E2 E3 \n" +
         "F1 F2 F3 \n" +
         "G1 G2 G3 \n" +
         "H1 H2 H3 \n" +
         "I1 I2 I3 \n" +
         "J1 J2 J3 \n" +
         "K1 K2 K3 \n" +
         "L1 L2 L3 \n" +
         "M1 M2 M3 \n" +
         "N1 N2 N3 \n" +
         "O1 O2 O3 \n"
      ;

      String ist06 = rufeAuf("schach05", "ABCDEFGHIJKLMNO", "123");

      assertEquals(soll06.length(), ist06.length());
      assertEquals(soll06, ist06);
   } // test_schach05_06
   // ---------------------------------------------------------------------
   public void test_schach05_07() {
      String soll07 =
         "A1 A2 A3 \n" +
         "B1 B2 B3 \n"
      ;

      String ist07 = rufeAuf("schach05", "AB", "123");

      assertEquals(soll07.length(), ist07.length());
      assertEquals(soll07, ist07);
   } // test_schach05_07
   // ---------------------------------------------------------------------
   public void test_schach05_08() {
      String soll08 =
         "A1 A2 \n" +
         "B1 B2 \n" +
         "C1 C2 \n"
      ;

      String ist08 = rufeAuf("schach05", "ABC", "12");

      assertEquals(soll08.length(), ist08.length());
      assertEquals(soll08, ist08);
   } // test_schach05_08
   // ---------------------------------------------------------------------
   public void test_schach05_09() {
      String soll09 =
         "A1 A2 \n" +
         "B1 B2 \n"
      ;

      String ist09 = rufeAuf("schach05", "AB", "12");

      assertEquals(soll09.length(), ist09.length());
      assertEquals(soll09, ist09);
   } // test_schach05_09
   // ---------------------------------------------------------------------
   public void test_schach05_10() {
      String soll10 =
         "A1 \n"
      ;

      String ist10 = rufeAuf("schach05", "A", "1");

      assertEquals(soll10.length(), ist10.length());
      assertEquals(soll10, ist10);
   } // test_schach05_10
   // ---------------------------------------------------------------------
   public void test_gitter01() {
      for (int x=-2; x<5; x++) {
         for (int y=-2; y<5; y++) {
            String soll = gitter(x, y);
            String ist  = rufeAuf("gitter", x, y);
            String meld = "gitter(" + x + "," + y + ")";

            assertEquals(meld, soll.length(), ist.length());
            assertEquals(meld, soll, ist);
         }
      }
   } // test_gitter01
   // ---------------------------------------------------------------------
   private String gitter(int s, int z) {
      // Mit dieser Funktion werden die Soll-Werte berechnet, mit denen
      // die Ergebnisse der Funktion Schleifen.gitter verglichen werden.

      s = Math.max(0, s);
      z = Math.max(0, z);

      StringBuilder zA  = new StringBuilder();
      StringBuilder zB  = new StringBuilder();
      StringBuilder erg = new StringBuilder();

      // Eine Zeile zA der Form +-+-+-+... erzeugen:
      zA.append("+");
      for (int is=0; is<s; is++) zA.append("-+");
      zA.append("\n");

      // Eine Zeile zB der Form | | | |... erzeugen:
      zB.append("|");
      for (int is=0; is<s; is++) zB.append(" |");
      zB.append("\n");

      // Ein Gitter beginnt immer mit einer Zeile der Form zA:
      erg.append(zA);

      // Dann folgen Paare von Zeilen zB und zA:
      for (int iz=0; iz<z; iz++) {
         erg.append(zB);
         erg.append(zA);
      }

      return erg.toString();
   } // gitter
   // ---------------------------------------------------------------------
   static public void main(String[] _) {
      // Alle Testfaelle werden ausgefuehrt:
      junit.awtui.TestRunner.run(SchleifenJut.class);
   }
   // ---------------------------------------------------------------------
   private String rufeAuf(final String METHODEN_NAME) {
      // Ruft reflektiv eine Methode mit Rueckgabetyp String und
      // 0 Parametern auf und liefert ihr Ergebnis als Ergebnis zurueck.
      try {
         Class<?> kob = Class.forName( KLASSEN_NAME);
         Method   met = kob.getMethod(METHODEN_NAME);

         String   erg = (String) met.invoke(null);
         return erg;

      } catch (Exception ex) {
         behandleAusnahmen(ex);
         return "Ein Fehler trat auf!";
      }
   } // rufeAuf
   // ---------------------------------------------------------------------
   private String rufeAuf(final String METHODEN_NAME,
                          final String S1,
                          final String S2)
      // Ruft reflektiv eine Methode mit Rueckgabetyp String und
      // 2 String-Parametern auf und liefert ihr Ergebnis als Ergebnis
      // zurueck.
   {
      try {
         Class<?> kob = Class.forName( KLASSEN_NAME);
         Method   met = kob.getMethod(METHODEN_NAME, String.class,
                                                     String.class);

         String   erg = (String) met.invoke(null, S1, S2);
         return erg;

      } catch (Exception ex) {
         behandleAusnahmen(ex);
         return "Ein Fehler trat auf!";
      }
   } // rufeAuf
   // ---------------------------------------------------------------------
   private String rufeAuf(final String METHODEN_NAME,
                          final int N1,
                          final int N2)
      // Ruft reflektiv eine Methode mit Rueckgabetyp String und
      // 2 int-Parametern auf und liefert ihr Ergebnis als Ergebnis
      // zurueck.
   {
      try {
         Class<?> kob = Class.forName( KLASSEN_NAME);
         Method   met = kob.getMethod(METHODEN_NAME, Integer.TYPE,
                                                     Integer.TYPE);

         String   erg = (String) met.invoke(null, N1, N2);
         return erg;

      } catch (Exception ex) {
         behandleAusnahmen(ex);
         return "Ein Fehler trat auf!";
      }
   } // rufeAuf
   // ---------------------------------------------------------------------
   void behandleAusnahmen(Exception ex) {
      String msg = ex.getMessage();
      if (ex instanceof NoSuchMethodException) {
         String met = msg.substring(msg.lastIndexOf('.')+1);
         fail("Die Methode " + met + " muss noch implementiert werden!");
      } else if (ex instanceof ClassNotFoundException) {
         fail("Die Klasse "  + msg + " muss noch implementiert werden!");
      } else {
         throw new Error(ex);
      }
   } // behandleAusnahmen
   // ---------------------------------------------------------------------
   // Eine Methode mit einem kurzen Namen:
   static void pln(Object ob) {System.out.println(ob);}
   // Eine Methode mit einem kurzen Namen:
   static void printf(String f, Object... v) {System.out.printf(f, v);}
   // ---------------------------------------------------------------------
} // class SchleifenJut
