// Datei TripelJut.java
/* ------------------------------------------------------------------------
Testprogramm, erstellt mit JUnit Version 3.8.2
zum Testen der Klasse Tripel.

Der Testfall test01 fuehrt   5 assert-Befehle aus
Der Testfall test02 fuehrt 100 assert-Befehle aus
Insgesamt werden also      105 assert-Befehle ausgefuehrt.
------------------------------------------------------------------------ */
import junit.framework.Test;      // Eine Schnittstelle
import junit.framework.TestCase;  // Eine Test-Klasse
import junit.framework.TestSuite; // Eine Test-Klasse

public class TripelJut extends TestCase {
   // ---------------------------------------------------------------------
   static public Test suite() {
      // Alle parameterlosen Prozeduren dieser Klasse, deren Namen mit
      // "test" beginnen, werden zu einem TestSuite-Objekt zusammengefasst
      // und als Ergebnis geliefert:
      return new TestSuite(TripelJut.class);
   } // suite
   // ---------------------------------------------------------------------
   // Die zu testenden Tripel-Objekte:
   Tripel[] tr = {
      new Tripel(0, 0, 0),
      new Tripel(1, 2, 3),

      new Tripel(3, 4, 5),  // Alle 6 Permutationen von 3, 4, 5
      new Tripel(3, 5, 4),
      new Tripel(4, 3, 5),
      new Tripel(4, 5, 3),
      new Tripel(5, 3, 4),
      new Tripel(5, 4, 3),

      new Tripel(0, 2, 2),  // Alle 3 Permutationen von 0, 2, 2
      new Tripel(2, 0, 2),
      new Tripel(2, 2, 0),

      new Tripel(2, 2, 5),  // Alle 3 Permutationen von 2, 2, 5
      new Tripel(2, 5, 2),
      new Tripel(5, 2, 2),

      new Tripel(0, 2, 3),  // Alle 6 Permutationen von 0, 2, 3
      new Tripel(0, 3, 2),
      new Tripel(2, 0, 3),
      new Tripel(2, 3, 0),
      new Tripel(3, 0, 2),
      new Tripel(3, 2, 0),
   }; // tr

   // Die Reihung der Soll-Werte sollR2 sollte fuer jedes Tripel tr[i]
   // eine Komponente sollR2[i] mit 5 boolean-Werten darin enthalten:
   boolean[][] sollR2 = {

   //  DREI    GLEICH  GLEICH  SCHIEF  RECHT       Zugehoeriges
   //  SEIT    SEITIG  SCHENK.         WINKLIG     Tripel in tr:
      {true,   true,   true,   false,  false},  // (0, 0, 0)
      {true,   false,  false,  true,   false},  // (1, 2, 3)

      {true,   false,  false,  true,   true },  // (3, 4, 5)
      {true,   false,  false,  true,   true },  // (3, 5, 4)
      {true,   false,  false,  true,   true },  // (4, 3, 5)
      {true,   false,  false,  true,   true },  // (4, 5, 3)
      {true,   false,  false,  true,   true },  // (5, 3, 4)
      {true,   false,  false,  true,   true },  // (5, 4, 3)

      {true,   false,  true,   false,  true },  // (0, 2, 2)
      {true,   false,  true,   false,  true },  // (2, 0, 2)
      {true,   false,  true,   false,  true },  // (2, 2, 0)

      {false,  false,  false,  false,  false},  // (2, 2, 5)
      {false,  false,  false,  false,  false},  // (2, 5, 2)
      {false,  false,  false,  false,  false},  // (5, 2, 2)

      {false,  false,  false,  false,  false},  // (0, 2, 3)
      {false,  false,  false,  false,  false},  // (0, 3, 2)
      {false,  false,  false,  false,  false},  // (2, 0, 3)
      {false,  false,  false,  false,  false},  // (2, 3, 0)
      {false,  false,  false,  false,  false},  // (3, 0, 2)
      {false,  false,  false,  false,  false},  // (3, 2, 0)
   }; // sollR2

   // Die Reihung ist_R2 der Ist-Werte. Sollte mit sollR2
   // uebereinstimmen (sonst gibt es keinen gruenen Balken).
   // Wird im Konstruktor TripelJut initialisiert.
   boolean[][] ist_R2 = new boolean[tr.length][];

   public TripelJut() {
      // Initialisiert die Reihung der Ist-Werte ist_R2
      for (int i=0; i<ist_R2.length; i++) {
         ist_R2[i] = toBoolReihung(tr[i]);
      }
   } // Konstruktor TripleJut
   // ---------------------------------------------------------------------
   static boolean[] toBoolReihung(Tripel t) {
      // Liefert die 5 booelan-Attribute von t als Reihung:
      return new boolean[]
         {t.IST_DREISEIT,
          t.IST_GLEICHSEITIG,
          t.IST_GLEICHSCHENKLIG,
          t.IST_SCHIEF,
          t.IST_RECHTWINKLIG
         };
   } // toBoolReihung
   // ---------------------------------------------------------------------
   String toString(Tripel t) {
      // Erzeugt aus den Attributen A, B, C von t einen String wie
      // z.B. "(3,7,4)":
      return "(" + t.A + "," + t.B + "," + t.C + ")";
   }
   // ---------------------------------------------------------------------
   // Die Namen der 5 boolean-Variablen in jedem Tripel-Objekt
   // (werden in Fehlermeldungen gebraucht):
   String[] varName = {
      "IST_DREISEIT",
      "IST_GLEICHSEITIG",
      "IST_GLEICHSCHENKLIG",
      "IST_SCHIEF",
      "IST_RECHTWINKLIG",
   };
   // ---------------------------------------------------------------------
   public void test01() {
      // Testet alle 5 boolean-Variablen von einem Tripel-Objekt t.
      // Die Methode assertEquals wird 5 Mal aufgerufen (jeweils mit
      // einer informativen Fehlermeldung meld).

      Tripel    t      = new Tripel(1, 2, 3);
      boolean[] ist_R1 = toBoolReihung(t);
      boolean[] sollR1 = {true, false, false, true, false};
      String    s      = toString(t);

      for (int j=0; j<ist_R1.length; j++) {
         boolean ist  = ist_R1 [j];
         boolean soll = sollR1 [j];
         String  meld = varName[j] + " von " + s + " ist falsch:";
         assertEquals(meld, soll, ist);
      }
   } // test01
   // ---------------------------------------------------------------------
   public void test02() {
      // Testet alle 5 boolean Variablen von jedem Tripel-Objekt in der
      // Reihung tr:
      // Die Methode assertEquals wird (5*tr.length) Mal aufgerufen
      // (jeweils mit einer informativen Fehlermeldung meld).

      for (int i=0; i<tr.length; i++) {   // Fuer jedes Tripel-Objekt
         Tripel    t      = tr    [i];
         boolean[] ist_R1 = ist_R2[i];
         boolean[] sollR1 = sollR2[i];
         String    s      = toString(t);

         for (int j=0; j<ist_R1.length; j++) { // Fuer jede boolean-Var.
            boolean ist  = ist_R1 [j];
            boolean soll = sollR1 [j];
            String  meld = varName[j] + " von " + s + " ist falsch:";
            assertEquals(meld, soll, ist);
         } // for i
      } // for j
   } // test02
   // ---------------------------------------------------------------------
   static public void main(String[] _) {
      pln("TripelJut: Jetzt geht es los!");
      // Alle Testfaelle werden ausgefuehrt:
      junit.awtui.TestRunner.run(TripelJut.class);
      pln("TripelJut: Das war's erstmal!");
   } // main
   // ---------------------------------------------------------------------
   // Eine Methode mit einem kurzen Namen:
   static void pln(Object ob) {System.out.println(ob);}
   // ---------------------------------------------------------------------
} // class TripelJut
