// Datei Veronika01Jut.java
/* ------------------------------------------------------------------------
Diese Klasse dient zum Testen der Klasse Veronika01.
Sie enthaelt 16 Testfaelle.
Getestet werden (nur) die Methoden liegenFalschRum01 und sortiere01
(die Methode gibAusIntReihung wird nur sehr oberflaechlich und die
Methode liesIntReihung gar nicht getestet).
---------------------------------------------------------------------------
Diese Klasse kann man auf 2 Arten ausfuehren lassen:

1. Indem man das Programm Veronika01Jut aufruft (siehe die main-Methode).

2. Indem man in einem bash- oder DOS-Fenster das folgende Kommando eingibt:
> java junit.awtui.TestRunner Veronika01Jut

Diese Klasse setzt das Rahmenprogramm Junit Version 3.8 voraus.
Es laeuft *nicht* mit Junit Version 4.0 oder spaeteren Versionen.
---------------------------------------------------------------------------
Diese Klasse kann man auf 2 Arten ausfuehren lassen:

1. Indem man das Programm FlorianJut aufruft (siehe die main-Methode).

2. Indem man in einem bash- oder DOS-Fenster das folgende Kommando eingibt:
> java junit.awtui.TestRunner FlorianJut

Diese Klasse setzt das Rahmenprogramm Junit Version 3.8 voraus.
Es laeuft *nicht* mit Junit Version 4.0 oder spaeteren Versionen.


------------------------------------------------------------------------ */
import junit.framework.Test;      // Eine Schnittstelle
import junit.framework.TestCase;  // Eine Test-Klasse
import junit.framework.TestSuite; // Eine Test-Klasse
import java.util.Arrays;

public class Veronika01Jut extends TestCase {
   // ---------------------------------------------------------------------
   // Wird AUS auf true gesetzt, werden beim Testen der Methode sortier01
   // umfangreiche Daten ausgegeben, unabhaengig von den Testergebnissen:
   static boolean AUS = false;
   // ---------------------------------------------------------------------
   static public Test suite() {
      // Alle parameterlosen Prozeduren dieser Klasse, deren Namen mit
      // "test" beginnen, werden zu einem TestSuite-Objekt zusammengefasst
      // und als Ergebnis geliefert:
      return new TestSuite(Veronika01Jut.class);
   } // suite
   // ---------------------------------------------------------------------
   private void fuehreEinenSort01TestAus(int[] par, int[] soll) {
      // Fuehrt *einen* Test der Methode sortiere01 durch. Falls der
      // assertTrue-Befehl missglueckt, wird eine aussagekraeftige
      // Meldung ausgegeben.

      String sSollN = Arrays.toString(soll);
      String sParV  = Arrays.toString(par);

      if (AUS) {
         pln("-------------------------------------------------------");
         p  ("parVorher : "); Veronika01.gibAusIntReihung(par);
      }

      Veronika01.sortiere01(par);

      if (AUS) {
         p  ("parNachher: "); Veronika01.gibAusIntReihung(par);
         p  ("soll      : "); Veronika01.gibAusIntReihung(soll);
      }

      String sParN  = Arrays.toString(par);
      String msg    = String.format("Methode sortiere01:%n" +
         "ParV:\t %s, %nSollN:\t %s, %nParN:\t %s",sParV, sSollN, sParN);
      assertTrue(msg, Arrays.equals(soll, par));
   } // fuehreEinenSort01TestAus
   // ---------------------------------------------------------------------
   public void test_liegenFalschRum01_01() {
      // Positive Faelle (Zahlen die falsch rum liegen):

      assertTrue (Veronika01.liegenFalschRum01(+1,  0));
      assertTrue (Veronika01.liegenFalschRum01( 0, -1));
      assertTrue (Veronika01.liegenFalschRum01(-1, -2));
      assertTrue (Veronika01.liegenFalschRum01(17, 15));
      assertTrue (Veronika01.liegenFalschRum01(+7, -5));
   }
   // ---------------------------------------------------------------------
   public void test_liegenFalschRum01_02() {
      // Negative Faelle (Zahlen die nicht falsch rum liegen),
      // u.a. gleiche Zahlen:

      assertFalse(Veronika01.liegenFalschRum01(+17, +17));
      assertFalse(Veronika01.liegenFalschRum01(-17, -17));
      assertFalse(Veronika01.liegenFalschRum01(+17, +27));
      assertFalse(Veronika01.liegenFalschRum01(-27, -17));
      assertFalse(Veronika01.liegenFalschRum01(-17, +27));
   }
   // ---------------------------------------------------------------------
   public void test_sortiere01_01() {
      if (AUS) {
         pln("*******************************************************");
         pln("Jetzt wird die Methode sort01 getestet:");
      }

      int[] par  = {2, 1, 3, 4, 5};
      int[] soll = {1, 2, 3, 4, 5};
      fuehreEinenSort01TestAus(par,soll);
   }
   // ---------------------------------------------------------------------
   public void test_sortiere01_02() {
      int[] par  = {1, 3, 2, 4, 5};
      int[] soll = {1, 2, 3, 4, 5};
      fuehreEinenSort01TestAus(par,soll);
   }
   // ---------------------------------------------------------------------
   public void test_sortiere01_03() {
      int[] par  = {1, 2, 4, 3, 5};
      int[] soll = {1, 2, 3, 4, 5};
      fuehreEinenSort01TestAus(par,soll);
   }
   // ---------------------------------------------------------------------
   public void test_sortiere01_04() {
      int[] par  = {1, 2, 3, 5, 4};
      int[] soll = {1, 2, 3, 4, 5};
      fuehreEinenSort01TestAus(par,soll);
   }
   // ---------------------------------------------------------------------
   public void test_sortiere01_05() {
      int[] par  = {5, 4, 3, 2, 1};
      int[] soll = {1, 2, 3, 4, 5};
      fuehreEinenSort01TestAus(par,soll);
   }
   // ---------------------------------------------------------------------
   public void test_sortiere01_06() {
      int[] par  = {1, 2, 3, 4, 5};
      int[] soll = {1, 2, 3, 4, 5};
      fuehreEinenSort01TestAus(par,soll);
   }
   // ---------------------------------------------------------------------
   public void test_sortiere01_07() {
      int[] par  = {2, 1};
      int[] soll = {1, 2};
      fuehreEinenSort01TestAus(par,soll);
   }
   // ---------------------------------------------------------------------
   public void test_sortiere01_08() {
      int[] par  = {2, 1};
      int[] soll = {1, 2};
      fuehreEinenSort01TestAus(par,soll);
   }
   // ---------------------------------------------------------------------
   public void test_sortiere01_09() {
      int[] par  = {1, 2};
      int[] soll = {1, 2};
      fuehreEinenSort01TestAus(par,soll);
   }
   // ---------------------------------------------------------------------
   public void test_sortiere01_10() {
      int[] par  = {1};
      int[] soll = {1};
      fuehreEinenSort01TestAus(par,soll);
   }
   // ---------------------------------------------------------------------
   public void test_sortiere01_11() {
      int[] par  = {};
      int[] soll = {};
      fuehreEinenSort01TestAus(par,soll);
   }
   // ---------------------------------------------------------------------
   public void test_sortiere01_12() {
      // Eine laengere Reihung mit gerader Laenge:
      int[] par  = new int[1000]; // Wird mit absteigenden Zahlen gefuellt
      int[] soll = new int[1000];
      for (int i=0; i<soll.length; i++) {
         par [i] = 17 * (1000-i);
         soll[i] = 17 * (   1+i);
      }

      fuehreEinenSort01TestAus(par,soll);
   }
   // ---------------------------------------------------------------------
   public void test_sortiere01_13() {
      // Eine laengere Reihung mit ungerader Laenge:

      // Wenn AUS den Wert true hat, werden 3 Reihungen ausgegeben(soll,
      // par vor dem Sortieren und dann noch einmal nach dem Sortieren).
      final boolean AUS = true;

      int[] par  = new int[1001]; // Wird mit absteigenden Zahlen gefuellt
      int[] soll = new int[1001];
      for (int i=0; i<soll.length; i++) {
         par [i] = -17 * (   1+i);
         soll[i] = -17 * (1001-i);
      }

      fuehreEinenSort01TestAus(par, soll);
   }
   // ---------------------------------------------------------------------
   public void test_gibAusIntReihung() {
      // Gibt eine leere Reihung aus und fragt den Benutzer vor dem
      // Bildschirm, ob er sie lesen kann:

      pln("");
      pln("*******************************************************");
      pln("Ist zwischen den beiden Minus-Zeilen");
      pln("hier drunter eine leere int-Reihung zu erkennen?   ");
      pln("-------------------------------------------------------");
      Veronika01.gibAusIntReihung(new int[0]);
      pln("-------------------------------------------------------");
      pln("");
   }
   // ---------------------------------------------------------------------
   static public void main(String[] _) {
      // Alle Testfaelle werden ausgefuehrt:
      junit.awtui.TestRunner.run(Veronika01Jut.class);
   } // main
   // ---------------------------------------------------------------------
   // Mehrere Methoden mit kurzen Namen:
   static void pln(Object ob) {System.out.println(ob);}
   static void p  (Object ob) {System.out.print  (ob);}
   static void pln()          {System.out.println();  }
      // ---------------------------------------------------------------------
} // class Veronika01Jut
