// Datei Veronika02Jut.java
/* ------------------------------------------------------------------------
Diese Klasse dient zum Testen der Klasse Veronika02.
Sie enthaelt 66 Testfaelle.
Getestet werden die Methoden
liegenFalschRum01, sortiere01,
liegenFalschRum02, sortiere02,
max, summe, enthaeltDoppelte, istPrim und maxPrim
(die Methode gibAusIntReihung wird nur sehr oberflaechlich und die
Methode liesIntReihung gar nicht getestet).
---------------------------------------------------------------------------
Diese Klasse kann man auf 2 Arten ausfuehren lassen:

1. Indem man das Programm Veronika02Jut aufruft (siehe die main-Methode).

2. Indem man in einem bash- oder DOS-Fenster das folgende Kommando eingibt:
> java junit.awtui.TestRunner Veronika02Jut

Diese Klasse setzt das Rahmenprogramm Junit Version 3.8 voraus.
Es laeuft *nicht* mit Junit Version 4.0 oder spaeteren Versionen.
------------------------------------------------------------------------ */
import junit.framework.Test;      // Eine Schnittstelle
import junit.framework.TestCase;  // Eine Test-Klasse
import junit.framework.TestSuite; // Eine Test-Klasse
import java.util.Arrays;

public class Veronika02Jut extends Veronika01Jut {
   // ---------------------------------------------------------------------
   // Wird AUS auf true gesetzt, werden beim Testen der Methoden sortier01
   // und sortiere02 umfangreiche Daten ausgegeben, unabhaengig von den
   // Testergebnissen:

   static {AUS = false;}
   // ---------------------------------------------------------------------
   static public Test suite() {
      // Alle parameterlosen Prozeduren dieser Klasse, deren Namen mit
      // "test" beginnen, werden zu einem TestSuite-Objekt zusammengefasst
      // und als Ergebnis geliefert:
      return new TestSuite(Veronika02Jut.class);
   } // suite
   // ---------------------------------------------------------------------
   public void test_Unterklasse() {
      // Wenn Veronika02 nicht als Erweiterung (oder: Unterklasse) von
      // Veronika01 vereinbart wurde, wird hier eine Ausnahme geworfen
      // (vermutlich ClassCastException)
      Veronika01 ve01;
      Object     ob01 = new Veronika02();
      try {
         ve01 = (Veronika01) ob01;
      } catch (Exception ex) {
         fail("Veronika02 ist keine Erweiterung von Veronika01!");
      }
   }
   // ---------------------------------------------------------------------
   public void test_liegenFalschRum02_01() {
      // Ungerade Zahlen muessen nach geraden Zahlen liegen:

      assertTrue (Veronika02.liegenFalschRum02( 21,  10));
      assertTrue (Veronika02.liegenFalschRum02( 21, -10));
      assertTrue (Veronika02.liegenFalschRum02(-21,  10));
      assertTrue (Veronika02.liegenFalschRum02(-21, -10));
      assertTrue (Veronika02.liegenFalschRum02( 11,  20));
      assertTrue (Veronika02.liegenFalschRum02( 11, -20));
      assertTrue (Veronika02.liegenFalschRum02(-11,  20));
      assertTrue (Veronika02.liegenFalschRum02(-11, -20));
   }
   // ---------------------------------------------------------------------
   public void test_liegenFalschRum02_02() {
      // Ungerade Zahlen sollen absteigend sortiert sein:

      assertTrue (Veronika02.liegenFalschRum02(-21, -11));
      assertTrue (Veronika02.liegenFalschRum02(-21,  11));
      assertTrue (Veronika02.liegenFalschRum02(-21,  21));
      assertTrue (Veronika02.liegenFalschRum02(-11,  11));
      assertTrue (Veronika02.liegenFalschRum02(-11,  21));
      assertTrue (Veronika02.liegenFalschRum02( 11,  21));
   }
   // ---------------------------------------------------------------------
   public void test_liegenFalschRum02_03() {
      // Gerade Zahlen sollen aufsteigend sortiert sein:

      assertTrue (Veronika02.liegenFalschRum02( 20,  10));
      assertTrue (Veronika02.liegenFalschRum02( 20, -10));
      assertTrue (Veronika02.liegenFalschRum02( 20, -20));
      assertTrue (Veronika02.liegenFalschRum02( 10, -10));
      assertTrue (Veronika02.liegenFalschRum02( 10, -20));
      assertTrue (Veronika02.liegenFalschRum02(-10, -20));
   }
   // ---------------------------------------------------------------------
   public void test_liegenFalschRum02_04() {
      // Gleiche Zahlen liegen nicht falsch rum:

      assertFalse (Veronika02.liegenFalschRum02( 10,  10));
      assertFalse (Veronika02.liegenFalschRum02( 11,  11));
      assertFalse (Veronika02.liegenFalschRum02(-10, -10));
      assertFalse (Veronika02.liegenFalschRum02(-11, -11));
   }
   // +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
   private void fuehreEinenSort02TestAus(int[] par, int[] soll) {
      // Fuehrt *einen* Test der Methode sortiere01 durch. Falls der
      // assertTrue-Befehl missglueckt, wird eine aussagekraeftige
      // Meldung ausgegeben.

      String sSollN = Arrays.toString(soll);
      String sParV  = Arrays.toString(par);

      if (AUS) {
         pln("-------------------------------------------------------");
         p  ("parVorher : "); Veronika01.gibAusIntReihung(par);
      }

      Veronika02.sortiere02(par);

      if (AUS) {
         p  ("parNachher: "); Veronika01.gibAusIntReihung(par);
         p  ("soll      : "); Veronika01.gibAusIntReihung(soll);
      }

      String sParN  = Arrays.toString(par);
      String msg    = String.format("Methode sortiere01:%n" +
         "ParV:\t %s, %nSollN:\t %s, %nParN:\t %s",sParV, sSollN, sParN);
      assertTrue(msg, Arrays.equals(soll, par));
   } // fuehreEinenSort02TestAus
   // ---------------------------------------------------------------------
   public void test_sortiere02_01() {
      if (AUS) {
         pln("*******************************************************");
         pln("Jetzt wird die Methode sort02 getestet:");
      }

      int[] par  = {10, 15, 20, 30, 35, 40, 55};
      int[] soll = {10, 20, 30, 40, 55, 35, 15};
      fuehreEinenSort02TestAus(par,soll);
   }
   // ---------------------------------------------------------------------
   public void test_sortiere02_02() {
      int[] par  = {55, 35, 15, 40, 30, 20, 10};
      int[] soll = {10, 20, 30, 40, 55, 35, 15};
      fuehreEinenSort02TestAus(par,soll);
   }
   // ---------------------------------------------------------------------
   public void test_sortiere02_03() {
      int[] par  = {15, 10, 40, 35, 55, 20, 30};
      int[] soll = {10, 20, 30, 40, 55, 35, 15};
      fuehreEinenSort02TestAus(par,soll);
   }
   // ---------------------------------------------------------------------
   public void test_sortiere02_04() {
      int[] par  = {30, 40, 20, 10};
      int[] soll = {10, 20, 30, 40};
      fuehreEinenSort02TestAus(par,soll);
   }
   // ---------------------------------------------------------------------
   public void test_sortiere02_05() {
      int[] par  = {15, 35, 55};
      int[] soll = {55, 35, 15};
      fuehreEinenSort02TestAus(par,soll);
   }
   // ---------------------------------------------------------------------
   public void test_sortiere02_06() {
      int[] par  = {15, 10};
      int[] soll = {10, 15};
      fuehreEinenSort02TestAus(par,soll);
   }
   // ---------------------------------------------------------------------
   public void test_sortiere02_07() {
      int[] par  = {15};
      int[] soll = {15};
      fuehreEinenSort02TestAus(par,soll);
   }
   // ---------------------------------------------------------------------
   public void test_sortiere02_08() {
      int[] par  = {10};
      int[] soll = {10};
      fuehreEinenSort02TestAus(par,soll);
   }
   // ---------------------------------------------------------------------
   public void test_sortiere02_09() {
      int[] par  = {};
      int[] soll = {};
      fuehreEinenSort02TestAus(par,soll);
   }
   // +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
   private void max(int[] orig, int sollMax) {
      // Die Funktion Veronika02.max soll ihren Reihungsparameter
      // nicht veraendern (d.h. nicht sortieren).
      String fm = "max soll seinen int[]-Param nicht veraender!";
      int[] kopi = orig.clone();
      assertEquals(sollMax, Veronika02.max(kopi));
      assertTrue(fm, Arrays.equals(orig, kopi));
   }
   // ---------------------------------------------------------------------
   public void test_max_01() {
      // Angewendet auf eine leere Reihung soll max den kleinst-moeglichen
      // int-Wert Integer.MIN_VALUE liefern:
      int[] orig = new int[0];
      max(orig, Integer.MIN_VALUE);
   }
   // ---------------------------------------------------------------------
   public void test_max_02() {
      int[] orig = new int[] {2, 5, 3, 1, 4};
      max(orig, 5);
   }
   // ---------------------------------------------------------------------
   public void test_max_03() {
      int[] orig = new int[] {-20, -10, -30};
      max(orig, -10);
   }
   // ---------------------------------------------------------------------
   public void test_summe_01() {
      // Die Summe aller Komponenten einer leeren int-Reihung ist 0:
      int[] ur = new int[0];
      assertEquals(0, Veronika02.summe(ur));
   }
   // ---------------------------------------------------------------------
   public void test_summe_02() {
      int[] ur = new int[] {10, 50, 30, 40, 20};
      assertEquals(150, Veronika02.summe(ur));
   }
   // ---------------------------------------------------------------------
   public void test_summe_03() {
      int[] ur = new int[] {-10, -50, -30, -40, -20};
      assertEquals(-150, Veronika02.summe(ur));
   }
   // +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
   private void enthaeltDoppelte(int[] orig, boolean b) {
      String fm = "enthaeltDoppelte soll seinen int[]-Param " +
                  "nicht veraendern!";
      int[] kopi = orig.clone();
      assertEquals(b, Veronika02.enthaeltDoppelte(kopi));
      assertTrue(fm, Arrays.equals(orig, kopi));
   }
   // ---------------------------------------------------------------------
   public void test_enthaeltDoppelte_01() {
      // Eine leere Reihung kann keine Doppelgaenger enthalten:
      int[] orig = new int[0];
      enthaeltDoppelte(orig, false);
   }
   // ---------------------------------------------------------------------
   public void test_enthaeltDoppelte_02() {
      // Eine Reihung der Laenge 1 kann keine Doppelgaenger enthalten:
      int[] orig = new int[] {123};
      enthaeltDoppelte(orig, false);
   }
   // ---------------------------------------------------------------------
   public void test_enthaeltDoppelte_03() {
      int[] orig = new int[] {1, 2, 3, 4, 5};          // ungerade Anzahl
      enthaeltDoppelte(orig, false);
   }
   // ---------------------------------------------------------------------
   public void test_enthaeltDoppelte_04() {
      // Doppegaenger vorn und unmittelbar nebeneinander:
      int[] orig = new int[] {1, 1, 2, 3, 4, 5};       // ungerade Anzahl
      enthaeltDoppelte(orig, true);
   }
   // ---------------------------------------------------------------------
   public void test_enthaeltDoppelte_05() {
      int[] orig = new int[] {1, 2, 1, 3, 4, 5};       // ungerade Anzahl
      enthaeltDoppelte(orig, true);
   }
   // ---------------------------------------------------------------------
   public void test_enthaeltDoppelte_06() {
      int[] orig = new int[] {1, 2, 3, 1, 4, 5};       // ungerade Anzahl
      enthaeltDoppelte(orig, true);
   }
   // ---------------------------------------------------------------------
   public void test_enthaeltDoppelte_07() {
      int[] orig = new int[] {1, 2, 3, 4, 1, 5};       // ungerade Anzahl
      enthaeltDoppelte(orig, true);
   }
   // ---------------------------------------------------------------------
   public void test_enthaeltDoppelte_08() {
      int[] orig = new int[] {1, 2, 3, 4, 5, 1};       // ungerade Anzahl
      enthaeltDoppelte(orig, true);
   }
   // ---------------------------------------------------------------------
   public void test_enthaeltDoppelte_09() {
      int[] orig = new int[] {1, 2, 3, 4, 5, 6};       // gerade Anzahl
      enthaeltDoppelte(orig, false);
   }
   // ---------------------------------------------------------------------
   public void test_enthaeltDoppelte_10() {
      int[] orig = new int[] {1, 2, 3, 4, 5, 6, 6};    // gerade Anzahl
      enthaeltDoppelte(orig, true);
   }
   // ---------------------------------------------------------------------
   public void test_enthaeltDoppelte_11() {
      int[] orig = new int[] {1, 2, 3, 4, 6, 5, 6};    // gerade Anzahl
      enthaeltDoppelte(orig, true);
   }
   // ---------------------------------------------------------------------
   public void test_enthaeltDoppelte_12() {
      int[] orig = new int[] {1, 2, 3, 6, 4, 5, 6};    // gerade Anzahl
      enthaeltDoppelte(orig, true);
   }
   // ---------------------------------------------------------------------
   public void test_enthaeltDoppelte_13() {
      int[] orig = new int[] {1, 2, 6, 3, 4, 5, 6};    // gerade Anzahl
      enthaeltDoppelte(orig, true);
   }
   // ---------------------------------------------------------------------
   public void test_enthaeltDoppelte_14() {
      int[] orig = new int[] {1, 6, 2, 3, 4, 5, 6};    // gerade Anzahl
      enthaeltDoppelte(orig, true);
   }
   // ---------------------------------------------------------------------
   public void test_enthaeltDoppelte_15() {
      int[] orig = new int[] {6, 1, 2, 3, 4, 5, 6};    // gerade Anzahl
      enthaeltDoppelte(orig, true);
   }
   // ---------------------------------------------------------------------
   public void test_istPrim_01() {
      // Die ersten 5 Primzahlen:
      assertTrue(Veronika02.istPrim(2));
      assertTrue(Veronika02.istPrim(3));
      assertTrue(Veronika02.istPrim(5));
      assertTrue(Veronika02.istPrim(7));
      assertTrue(Veronika02.istPrim(11));
   }
   // ---------------------------------------------------------------------
   public void test_istPrim_02() {
      // Die ersten 5 nicht-Primzahlen
      assertFalse(Veronika02.istPrim(0));
      assertFalse(Veronika02.istPrim(1));
      assertFalse(Veronika02.istPrim(4));
      assertFalse(Veronika02.istPrim(6));
      assertFalse(Veronika02.istPrim(8));
      assertFalse(Veronika02.istPrim(9));
   }
   // ---------------------------------------------------------------------
   public void test_istPrim_03() {
      // Die ersten 5 Primzahlen:
      assertTrue(Veronika02.istPrim(-2));
      assertTrue(Veronika02.istPrim(-3));
      assertTrue(Veronika02.istPrim(-5));
      assertTrue(Veronika02.istPrim(-7));
      assertTrue(Veronika02.istPrim(-11));
   }
   // ---------------------------------------------------------------------
   public void test_istPrim_04() {
      // Die ersten 5 nicht-Primzahlen
      assertFalse(Veronika02.istPrim(-1));
      assertFalse(Veronika02.istPrim(-4));
      assertFalse(Veronika02.istPrim(-6));
      assertFalse(Veronika02.istPrim(-8));
      assertFalse(Veronika02.istPrim(-9));
   }
   // ---------------------------------------------------------------------

   public void test_istPrim_05() {
      // Groessere Primzahlen und nicht-Primzahlen:
      assertTrue (Veronika02.istPrim(2027));
      assertTrue (Veronika02.istPrim(20011));
      assertTrue (Veronika02.istPrim(10000019));
      assertFalse(Veronika02.istPrim(2027*2027));
      assertFalse(Veronika02.istPrim(2027*20011));
      assertFalse(Veronika02.istPrim(20011*20011));
   }
   // +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
   private void maxPrim(int[] orig, int sollMaxPrim) {
      String fm = "maxPrim soll seinen int[]-Param nicht veraendern!";
      int[] kopi = orig.clone();
      assertEquals(sollMaxPrim, Veronika02.maxPrim(kopi));
      assertTrue(fm, Arrays.equals(orig, kopi));
   }
   // ---------------------------------------------------------------------
   public void test_maxPrim_01() {
      // Eine leere Reihung enthaelt keine Primzahlen:
      int[] orig = new int[0];
      maxPrim(orig, 0);
   }
   // ---------------------------------------------------------------------
   public void test_maxPrim_02() {
      // Eine Reihung der Laenge 1 mit einer positiven Primzahl:
      int[] orig = new int[] {3};
      maxPrim(orig, 3);
   }
   // ---------------------------------------------------------------------
   public void test_maxPrim_03() {
      // Eine Reihung der Laenge 1 mit einer negativen Primzahl:
      int[] orig = new int[] {-3};
      maxPrim(orig, -3);
   }
   // ---------------------------------------------------------------------
   public void test_maxPrim_04() {
      // Eine Reihung der Laenge 1 ohne Primzahl:
      int[] orig = new int[] {4};
      maxPrim(orig, 0);
   }
   // ---------------------------------------------------------------------
   public void test_maxPrim_05() {
      // Eine Reihung der Laenge 1 ohne Primzahl:
      int[] orig = new int[] {-4};
      maxPrim(orig, 0);
   }
   // ---------------------------------------------------------------------
   public void test_maxPrim_06() {
      int[] orig = new int[] {1, 2, 3, 4, 5, 6};
      maxPrim(orig, 5);
   }
   // ---------------------------------------------------------------------
   public void test_maxPrim_07() {
      // Hier ist die groesste Primzahl negativ:
      int[] orig = new int[] {-1, -2, -3, -4, -5, -6};
      maxPrim(orig, -2);
   }
   // ---------------------------------------------------------------------
   public void test_maxPrim_08() {
      int[] orig = new int[] {1, -1, 2, -2, 3, -3, 4, -4, 5, -5, 6, -6};
      maxPrim(orig, 5);
   }
   // ---------------------------------------------------------------------
   public void test_maxPrim_09() {
      // Hier ist die einzige Primzahl negativ:
      int[] orig = new int[] {10, 20, 30, -17, 40, 50, 60};
      maxPrim(orig, -17);
   }
   // ---------------------------------------------------------------------
   public void test_maxPrim_10() {
      // Hier ist die einzige Primzahl negativ:
      int[] orig = new int[] {10, 20, 30, 40, 50, 60};
      maxPrim(orig, 0);
   }
   // ---------------------------------------------------------------------
   static public void main(String[] _) {
      // Alle Testfaelle werden ausgefuehrt:
      junit.awtui.TestRunner.run(Veronika02Jut.class);
/*
      // Jetzt wird eine leere Reihung ausgegeben und der Benutzer
      // wird gefragt, ob er sie lesen kann:
      pln("Ist hier eine leere Reihung von int-Werten zu erkennen?");
      pln("-------------------------------------------------------");
      Veronika02.gibAusIntReihung(new int[0]);
      pln("-------------------------------------------------------");
*/
   }
   // ---------------------------------------------------------------------
   // Eine Methode mit einem kurzen Namen:
   static void pln(Object ob) {System.out.println(ob);}
   // ---------------------------------------------------------------------
} // class Veronika02Jut
/* ------------------------------------------------------------------------
Ausgabe dieses Programms (wenn eine geeignete Klasse Veronika02 getestet
wird):

Ist hier eine leere Reihung von int-Werten zu erkennen?
-------------------------------------------------------
0 int-Komponenten: []
-------------------------------------------------------
------------------------------------------------------------------------ */
